package com.example.controls;

import java.util.ArrayList;
import java.util.List;

import com.mindfusion.diagramming.DiagramItem;
import com.mindfusion.diagramming.DiagramNode;
import com.mindfusion.diagramming.DiagramView;
import com.mindfusion.diagramming.MenuItemEvent;
import com.mindfusion.diagramming.RadialMenuItem;
import com.mindfusion.diagramming.MenuItemListener;
import com.mindfusion.diagramming.NodeListView;
import com.mindfusion.diagramming.RadialMenuEvent;
import com.mindfusion.diagramming.DiagramAdapter;
import com.mindfusion.diagramming.Shape;
import com.mindfusion.diagramming.ShapeNode;

import android.os.Bundle;
import android.app.Activity;
import android.view.Menu;


public class MainActivity extends Activity
{
	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		nodeListView = (NodeListView) findViewById(R.id.node_list_view);
		init();
	}

	private void init()
	{
		String shapes[] =
		{
			"Rectangle", "Ellipse", "RoundRect", "Decision", "Process", "Cylinder",
			"Arrow1", "Arrow2", "Arrow3", "Arrow4", "Arrow5", "Arrow6"
		};

		List<DiagramNode> nodes = new ArrayList<DiagramNode>();
		for (String shape : shapes)
		{
			ShapeNode p = new ShapeNode();
			p.setShape(Shape.fromId(shape));
			nodes.add(p);
		}
		nodeListView.addNodes(nodes, shapes);
		diagramView = (DiagramView)findViewById(R.id.diag_view);
		nodeListView.setDiagramView(diagramView);
		
		diagramView.getDiagram().addDiagramListener(new DiagramAdapter()
		{
			@Override
			public void contextMenuOpening(RadialMenuEvent e)
			{
				final DiagramItem diagramItem = e.getItem();
				e.getMenu().addMenuItem(R.drawable.square1,
					new MenuItemListener()
					{
						public void onTouchUp(MenuItemEvent e)
						{
							if (diagramItem instanceof ShapeNode)
							{
								ShapeNode node = (ShapeNode)diagramItem;
								node.setShape(Shape.fromId("Rectangle"));
							}
						}
					});
				e.getMenu().addMenuItem(R.drawable.circle1, 
					new MenuItemListener()
					{
						public void onTouchUp(MenuItemEvent e)
						{
							if(diagramItem instanceof ShapeNode)
							{
								ShapeNode node = (ShapeNode)diagramItem;
								node.setShape(Shape.fromId("Ellipse"));
							}
						}
					});
			}
		});
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu)
	{
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
	
	private DiagramView diagramView;
	private NodeListView nodeListView;
}