package com.example.tutorial1;

import java.util.HashMap;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import android.os.Bundle;
import android.app.Activity;
import android.graphics.RectF;
import android.view.Menu;

import com.mindfusion.diagramming.Diagram;
import com.mindfusion.diagramming.DiagramNode;
import com.mindfusion.diagramming.DiagramView;
import com.mindfusion.diagramming.LayeredLayout;
import com.mindfusion.diagramming.ShapeNode;


public class MainActivity extends Activity
{
	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		HashMap<String, DiagramNode> nodeMap = new HashMap<String, DiagramNode>();
		RectF bounds = new RectF(0, 0, 16, 8);
		
		DiagramView diagramView = (DiagramView)findViewById(R.id.diag_view);
		Diagram diagram = diagramView.getDiagram();

		try
		{
			// load the graph xml
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			DocumentBuilder builder = factory.newDocumentBuilder();
			Document xml = builder.parse(
				getAssets().open("SampleGraph.xml"));
			Element graph = (Element)xml.getFirstChild();
			
			// load node data
			NodeList nodes = graph.getElementsByTagName("Node");
			for (int n = 0; n < nodes.getLength(); n++)
			{
				Element node = (Element)nodes.item(n);
			    ShapeNode diagramNode = diagram.getFactory().createShapeNode(bounds);
			    nodeMap.put(node.getAttribute("id"), diagramNode);
			    diagramNode.setText(node.getAttribute("name"));
			}

			// load link data
			NodeList links = graph.getElementsByTagName("Link");
			for (int l = 0; l < links.getLength(); l++)
			{
				Element link = (Element)links.item(l);
			    diagram.getFactory().createDiagramLink(
			        nodeMap.get(link.getAttribute("origin")),
			        nodeMap.get(link.getAttribute("target")));
			}

			// arrange the graph
			LayeredLayout layout = new LayeredLayout();
			layout.setLayerDistance(16);
			layout.arrange(diagram);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu)
	{
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

}
